#include "Event.h"

char Event::getType() const 
{
	return type;
}
	
int Event::getTime() const 
{
	return time;
}

int Event::getTransTime() const 
{
	return ttime;
}
	
	
void Event::set(char t, int tm, int tt)
{
	type=t;
	time=tm;
	ttime=tt;
}

bool Event::operator>(const Event& rhs)const 
{
	bool result = false;
	if(time > rhs.getTime())
	  result = true;
	else if (time == rhs.getTime() && type < rhs.getType())
	  result = true;

	return result;
} 

bool Event::operator<(const Event& rhs)const 
{
	bool result = false;
	if(time < rhs.getTime())
	  result = true;
	else if (time == rhs.getTime() && type < rhs.getType())
	  result = true;

	return result;
} 

bool Event::operator<=(const Event& rhs)const 
{
	bool result = false;
	if(time <= rhs.getTime())
	  result = true;
	else if (time == rhs.getTime() && type < rhs.getType())
	  result = true;

	return result;
} 

bool Event::operator>=(const Event& rhs)const 
{
	bool result = false;
	if(time >= rhs.getTime())
	  result = true;

	return result;
} 

bool Event::operator==(const Event& rhs)const 
{
	return (time == rhs.getTime() && type == rhs.getType());
}

bool Event::operator!=(const Event& rhs)const 
{
	return (time != rhs.getTime() || type != rhs.getType());
}

std::ostream &operator<<(std::ostream &output, const Event &event)
{
	output << event.getType() << ": " << event.getTime() << "\n";
	return output;
}
